package xyz.lychee.lagfixer.libs.adventure.pointer;

import java.util.Optional;
import java.util.function.Supplier;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.UnknownNullability;

public interface Pointered {
   default <T> @NotNull Optional<T> get(final @NotNull Pointer<T> pointer) {
      return this.pointers().get(pointer);
   }

   @Contract("_, null -> _; _, !null -> !null")
   default <T> @Nullable T getOrDefault(final @NotNull Pointer<T> pointer, final @Nullable T defaultValue) {
      return this.pointers().getOrDefault(pointer, defaultValue);
   }

   default <T> @UnknownNullability T getOrDefaultFrom(final @NotNull Pointer<T> pointer, final @NotNull Supplier<? extends T> defaultValue) {
      return this.pointers().getOrDefaultFrom(pointer, defaultValue);
   }

   default @NotNull Pointers pointers() {
      return Pointers.empty();
   }
}
